<script setup lang="ts">
import { computed, onMounted, ref, watch } from 'vue'
import type { VForm } from 'vuetify/components'
import { usePromotionStore } from '@/stores/promotion'
import { format } from 'date-fns'
import { useCategoryStore } from '@/stores/category'
const promotions = computed(() => PromotionStore.promotions.value)
const PromotionStore = usePromotionStore()
const categoryStore = useCategoryStore()
const currentDate = ref()
const currentTime = ref()
const date: Date = new Date()
const now = new Date()
const time = new Date().toLocaleTimeString()

function formatDate(date: Date): string {
  return format(date, 'dd-MM-yyyy')
}

const setupDateAndTime = () => {
  currentDate.value = `${now.getDate()}/${now.getMonth() + 1}/${now.getFullYear()}`
  currentTime.value = `${time}:${now.getMinutes()}`

  setInterval(() => {
    const newNow = new Date()
    currentDate.value = `${newNow.getDate()}/${newNow.getMonth() + 1}/${newNow.getFullYear()}`
    currentTime.value = `${newNow.toLocaleTimeString()}`
  }, 1000)
}

onMounted(() => {
  PromotionStore.getPromotions()
  categoryStore.getCategorys()
  setupDateAndTime()
})

watch(
  () => PromotionStore.editedPromotion.value.details,
  (newVal, oldVal) => {
    if (newVal === 'Guest') {
      PromotionStore.editedPromotion.value.pointUse = 0
    }
  }
)
</script>

<template>
  <div>
    <v-sheet>
      <v-container fluid>
        <v-toolbar flat>
          <v-toolbar-title>Promotion Management</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-dialog v-model="PromotionStore.dialog.value" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn size="40px" v-bind="props" prepend-icon="mdi-plus-thick" class="mr-5">
                <!-- New User -->
              </v-btn>
            </template>
            <v-card style="background-color: #fff5e8">
              <v-card-title>
                <span class="text-h5">New Promotion</span>
              </v-card-title>
              <v-card-text>
                <v-form
                  v-model="PromotionStore.from.value"
                  @submit.prevent="PromotionStore.onSubmit"
                >
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="PromotionStore.editedPromotion.value.name"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        >
                        </v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="PromotionStore.editedPromotion.value.discount"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Discount"
                          type="number"
                        >
                        </v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <!-- <v-text-field v-model="PromotionStore.editedPromotion.value.startPro"
                          :rules="[(v) => !!v || 'Field is required']" clearable label="StartPro"
                          type="Date"></v-text-field> -->
                        <v-text-field
                          v-model="PromotionStore.editedPromotion.value.startDate"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="StartDate"
                          type="Date"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="PromotionStore.editedPromotion.value.endDate"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="EndDate"
                          type="Date"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-select
                          label="Details"
                          :items="['Guest', 'Member']"
                          v-model="PromotionStore.editedPromotion.value.details"
                        ></v-select>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-select
                          label="Category"
                          :items="categoryStore.categorys"
                          item-title="name"
                          item-value="id"
                          v-model="PromotionStore.editedPromotion.value.category"
                          :return-object="true"
                        ></v-select>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-select
                          label="Status"
                          :items="['Active', 'Inactive']"
                          v-model="PromotionStore.editedPromotion.value.status"
                          outlined
                        ></v-select>
                      </v-col>
                      <v-col
                        cols="12"
                        sm="12"
                        md="4"
                        v-if="PromotionStore.editedPromotion.value.details === 'Member'"
                      >
                        <v-text-field
                          v-model="PromotionStore.editedPromotion.value.pointUse"
                          label="PointUsed"
                          type="number"
                          clearable
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn variant="text" @click="PromotionStore.save()"> Save </v-btn>
                <v-btn variant="text" @click="PromotionStore.closeDialog()"> Close </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <v-dialog v-model="PromotionStore.dialogDelete.value" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn variant="text" @click="PromotionStore.closeDelete">Cancel</v-btn>
                <v-btn variant="text" @click="PromotionStore.deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>

        <v-table fixed-header height="530">
          <thead>
            <tr>
              <th>Id</th>
              <th>Name</th>
              <th>Discount</th>
              <th>Start Date</th>
              <th>End Date</th>
              <th>Details</th>
              <th>Category</th>
              <th>Status</th>
              <th>Point Used</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="item in promotions" :key="item.id">
              <td>{{ item.id }}</td>
              <td>{{ item.name }}</td>
              <td>{{ item.discount }}</td>
              <td>{{ formatDate(item.startDate) }}</td>
              <td>{{ formatDate(item.endDate) }}</td>
              <td>{{ item.details }}</td>
              <td>{{ item.category.name }}</td>
              <td>{{ item.status }}</td>
              <td>{{ item.pointUse }}</td>
              <td>
                <v-icon size="small" class="me-2" @click="PromotionStore.editItem(item)">
                  mdi-pencil
                </v-icon>
                <v-icon size="small" @click="PromotionStore.deleteItem(item)"> mdi-delete </v-icon>
              </td>
            </tr>
          </tbody>

          <template v-if="!promotions.length">
            <v-btn @click="PromotionStore.getPromotions"> Reset </v-btn>
          </template>
        </v-table>
      </v-container>
    </v-sheet>
  </div>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
}
</style>
